package com.example.android.constantesvitales;

import android.content.Context;
import android.content.res.Resources;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;


public class ConstantesAdapter extends ArrayAdapter<ConstanteVital> {

    Resources mRecursos;

    public ConstantesAdapter(Context context, ArrayList<ConstanteVital> constantesVitales,
                             Resources r) {
        super(context, 0, constantesVitales);
        mRecursos = r;
    }


    @Override
    public View getView(int position, @Nullable View convertView, @NonNull ViewGroup parent) {
        View elementoListaView = convertView;
        if (elementoListaView == null) {
            elementoListaView = LayoutInflater.from(getContext()).inflate(R.layout.elemento_lista,
                    parent, false);

        }

        ConstanteVital constanteActual = getItem(position);

        TextView descripcion = (TextView) elementoListaView.findViewById(R.id.descr_constantes);
        descripcion.setText(constanteActual.getNombre());

        if (constanteActual.getNombre()==mRecursos.getString(R.string.imc)) {
            TextView valorTextView = (TextView) elementoListaView.findViewById
                    (R.id.valor_constantes);
            if(constanteActual.getValorDouble()<0 || constanteActual.getValorDouble()>100){
                valorTextView.setText("--");
            }
            else {
                valorTextView.setText(String.format("%.1f", constanteActual.getValorDouble()));
            }
        }
        else {
            TextView valorTextView = (TextView) elementoListaView.findViewById
                    (R.id.valor_constantes);
            if(constanteActual.getValor()==0) {
                valorTextView.setText("--");
            }
            else {
                valorTextView.setText(Integer.toString(constanteActual.getValor()));;
            }
        }

        ImageView iconoView = (ImageView) elementoListaView.findViewById(R.id.icono_constantes);
        iconoView.setImageResource(constanteActual.getIcono());

        return elementoListaView;
    }
}

