#define B_RATE_RAPIDO 115200
#define B_RATE_LENTO 9600

#define T_SERVICIO 100

#define LED_IR 23
#define LED_R 24
#define Vo0 A0
#define Vo1 A1
#define Vo2 A2

unsigned long t_ciclo;
int lectura[3];

/////////////////////////////////////////////////////////////////////////////
void setup() 
{
  Serial.begin(B_RATE_LENTO);
  
  pinMode(LED_IR, OUTPUT);
  pinMode(LED_R, OUTPUT);
  pinMode(Vo0, INPUT);
  pinMode(Vo1, INPUT);
  pinMode(Vo2, INPUT);
  
  analogReference(AR_DEFAULT);                  //Referencia de AnalogRead a 3.3V
  analogWriteResolution(10);                    //10 bits (0-1023) para valores de tensión de salida
  analogReadResolution(12);                     //12 bits (0-4095) para lectura de tensión
  
  digitalWrite(LED_R, LOW);
  digitalWrite(LED_IR, LOW);
}

/////////////////////////////////////////////////////////////////////////////
void loop()
{
  t_ciclo=micros();

  Pulso_LED(LED_IR);
  while((micros()-t_ciclo)<1000)              //PERIODO
    continue;                      
  
  Envia_Datos();
}


/////////////////////////////////////////////////////////////////////////////
void Pulso_LED(int led)
{
  unsigned long t=micros();
  
  digitalWrite(led, HIGH);
  
  while((micros()-t)<T_SERVICIO)                   //TIEMPO DE SERVICIO ON
  {
    lectura[0]=analogRead(Vo0);
    lectura[1]=analogRead(Vo1);
    lectura[2]=analogRead(Vo2);
  }
  
  digitalWrite(led, LOW);
}


//////////////////////////////////////////////////////////////////////////////
void Envia_Datos()
{
  Serial.print(lectura[0]*3.3*1000/4095);
  Serial.print(",");
  Serial.print(lectura[1]*3.3*1000/4095);
  Serial.print(",");
  Serial.println(lectura[2]*3.3*1000/4095);
}


//////////////////////////////////////////////////////////////////////////////
float Lectura_Vo0()
{
  return(analogRead(Vo0)*3.3*1000/4095);
}

//////////////////////////////////////////////////////////////////////////////
float Lectura_Vo1()
{
  return(analogRead(Vo1)*3.3*1000/4095);
}

//////////////////////////////////////////////////////////////////////////////
float Lectura_Vo2()
{
  return(analogRead(Vo2)*3.3*1000/4095);
}
